'*************************************************************************
'
'   Copyright 2004
'   Envision IT Inc., all rights reserved
'   www.envisionIT.com
'
'*************************************************************************
'
'   Project: Envision IT StreetPerfect.Net Demo
'
'   Component:  frmValidate
'
'   Purpose: Displays a list of possible corrections for the address provided
'
'*************************************************************************
Option Explicit On 

Public Class frmValidate
  Inherits System.Windows.Forms.Form

  ' Keeps the return results from the web service call to be used when selecting an item
  ' and closing the dialog
  Private m_objAddresses As StreetPerfect.ProcessedAddressStruct

#Region " Windows Form Designer generated code "

  Public Sub New()
    MyBase.New()

    'This call is required by the Windows Form Designer.
    InitializeComponent()

    'Add any initialization after the InitializeComponent() call

  End Sub

  'Form overrides dispose to clean up the component list.
  Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
    If disposing Then
      If Not (components Is Nothing) Then
        components.Dispose()
      End If
    End If
    MyBase.Dispose(disposing)
  End Sub

  'Required by the Windows Form Designer
  Private components As System.ComponentModel.IContainer

  'NOTE: The following procedure is required by the Windows Form Designer
  'It can be modified using the Windows Form Designer.  
  'Do not modify it using the code editor.
  Friend WithEvents cmdCancel As System.Windows.Forms.Button
  Friend WithEvents lstAddresses As System.Windows.Forms.ListBox
  Friend WithEvents cmdCorrect As System.Windows.Forms.Button
  Friend WithEvents cmdIgnore As System.Windows.Forms.Button
  <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
    Me.cmdCancel = New System.Windows.Forms.Button
    Me.cmdCorrect = New System.Windows.Forms.Button
    Me.lstAddresses = New System.Windows.Forms.ListBox
    Me.cmdIgnore = New System.Windows.Forms.Button
    Me.SuspendLayout()
    '
    'cmdCancel
    '
    Me.cmdCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel
    Me.cmdCancel.Location = New System.Drawing.Point(280, 176)
    Me.cmdCancel.Name = "cmdCancel"
    Me.cmdCancel.Size = New System.Drawing.Size(72, 32)
    Me.cmdCancel.TabIndex = 5
    Me.cmdCancel.Text = "Cancel"
    '
    'cmdCorrect
    '
    Me.cmdCorrect.Location = New System.Drawing.Point(56, 176)
    Me.cmdCorrect.Name = "cmdCorrect"
    Me.cmdCorrect.Size = New System.Drawing.Size(80, 32)
    Me.cmdCorrect.TabIndex = 4
    Me.cmdCorrect.Text = "Correct and Save"
    '
    'lstAddresses
    '
    Me.lstAddresses.Location = New System.Drawing.Point(16, 15)
    Me.lstAddresses.Name = "lstAddresses"
    Me.lstAddresses.Size = New System.Drawing.Size(376, 134)
    Me.lstAddresses.TabIndex = 3
    '
    'cmdIgnore
    '
    Me.cmdIgnore.Location = New System.Drawing.Point(168, 176)
    Me.cmdIgnore.Name = "cmdIgnore"
    Me.cmdIgnore.Size = New System.Drawing.Size(80, 32)
    Me.cmdIgnore.TabIndex = 6
    Me.cmdIgnore.Text = "Ignore and Save"
    '
    'frmValidate
    '
    Me.AcceptButton = Me.cmdCorrect
    Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
    Me.CancelButton = Me.cmdCancel
    Me.ClientSize = New System.Drawing.Size(408, 229)
    Me.Controls.Add(Me.cmdIgnore)
    Me.Controls.Add(Me.cmdCancel)
    Me.Controls.Add(Me.cmdCorrect)
    Me.Controls.Add(Me.lstAddresses)
    Me.Name = "frmValidate"
    Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent
    Me.Text = "Validate Address"
    Me.ResumeLayout(False)

  End Sub

#End Region

  '-----------------------------------------------------------------------------------------
  ' Event Handlers
  '-----------------------------------------------------------------------------------------

  '-----------------------------------------------------------------------------------------
  '    Event:   frmValidate_Load
  '
  '    Purpose:  start here - the form is being loaded
  '              Calls the web service and populates the list box with matching addresses
  '-----------------------------------------------------------------------------------------
  Private Sub frmValidate_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    Dim lobjStreetPerfect As New StreetPerfect.StreetPerfect
    Dim ii As Integer
    Dim lsStatus As String

    ' Call the web service with the code from the main window
    m_objAddresses = lobjStreetPerfect.CorrectAddress(gstrGUID, _
                                                      gobjMain.txtAddress.Text, _
                                                      gobjMain.txtCity.Text, _
                                                      gobjMain.txtProvince.Text, _
                                                      gobjMain.txtCode.Text, _
                                                      gobjMain.txtCountry.Text)

    ' here is the result
    lsStatus = m_objAddresses.sStatus

    'These are return codes from StreetPerfect
    ' see the guidebook
    ' http://www.streetperfect.net/download/StreetPerfect.net%20Developer%20GuideBook.pdf
    'PARAMETER_ERROR As String = "X"
    'UNIDENTIFIED_ERROR As String = "U"
    'VALID As String = "V"
    'CORRECTED As String = "C"
    'NOT_CORRECT As String = "N"
    'FOREIGN As String = "F"
    'INVALID_GUID As String = "S"

    ' Check to see if the address is already valid
    If lsStatus = "V" Then
      ' If so then we don't need to do anything else
      MsgBox("The address is valid.  Normally this message would not be displayed, and the save would continue as normal.", vbOKOnly)
      Me.Close()
      ' Make sure we get something back
    ElseIf (lsStatus = "C" Or lsStatus = "N") AndAlso (Not IsNothing(m_objAddresses.Addresses)) Then

      ' Loop through each address and add it to the list box
      For ii = 0 To m_objAddresses.Addresses.GetUpperBound(0)
        ' See if a range is provided
        If m_objAddresses.Addresses(ii).sRange <> "" Then
          ' If it is then show the range and parity
          lstAddresses.Items.Add(m_objAddresses.Addresses(ii).sRange & " (" & _
                                 m_objAddresses.Addresses(ii).sParity & ") " & _
                                 m_objAddresses.Addresses(ii).sStreetAddress & " " & _
                                 m_objAddresses.Addresses(ii).sCity & ", " & _
                                 m_objAddresses.Addresses(ii).sProv & " " & _
                                 m_objAddresses.Addresses(ii).sCode & " " & _
                                 m_objAddresses.Addresses(ii).sCountry)
        Else
          ' If not then just show the address
          lstAddresses.Items.Add(m_objAddresses.Addresses(ii).sStreetAddress & " " & _
                                 m_objAddresses.Addresses(ii).sCity & ", " & _
                                 m_objAddresses.Addresses(ii).sProv & " " & _
                                 m_objAddresses.Addresses(ii).sCode & " " & _
                                 m_objAddresses.Addresses(ii).sCountry)
        End If
      Next ii

      ' Select the first item in the list
      lstAddresses.SelectedIndex = 0
    Else
      ' report status
      If lsStatus = "S" Then
        ' this is common, the GUID is wrong
        ' and S can be confused with successs
        MsgBox(gstrGUID & " is an invalid GUID for the Streetperfect webservice !", vbCritical)
      Else
        MsgBox("WebService returned Status " & lsStatus, vbCritical)
      End If

      ' close form on error
      Me.Close()
    End If
  End Sub

  '-----------------------------------------------------------------------------------------
  '    Event: cmdCancel_Click
  '
  '    Purpose: Cancel - return to main form - do nothing
  '-----------------------------------------------------------------------------------------
  Private Sub cmdCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCancel.Click, cmdIgnore.Click
    ' Just close the window
    ActiveForm.Close()
  End Sub

  '-----------------------------------------------------------------------------------------
  '    Event: lstAddresses_dblClick
  '
  '    Purpose: double click on an address in the list is like selecting it, and clicking correct
  '-----------------------------------------------------------------------------------------
  Private Sub lstAddresses_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles lstAddresses.DoubleClick
    ' Populate the fields on the main form
    PopulateMain()
    ' Close the window
    ActiveForm.Close()
  End Sub

  '-----------------------------------------------------------------------------------------
  '    Event: cmdCorrect_Click
  '
  '    Purpose: Correct button - correct the selected address
  '-----------------------------------------------------------------------------------------
  Private Sub cmdCorrect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCorrect.Click
    ' Populate the fields on the main form
    PopulateMain()
    ' Close the window
    ActiveForm.Close()
  End Sub

  '-----------------------------------------------------------------------------------------
  ' Private Methods
  '-----------------------------------------------------------------------------------------
  '-----------------------------------------------------------------------------------------
  '
  '    Property:  PopulateMain
  '
  '    Purpose:   Populates the main form fields from the selected list item
  '
  '    Arguments: None
  '
  '    Returns: None - updates main form directly
  '
  '-----------------------------------------------------------------------------------------
  Private Sub PopulateMain()
    ' Make sure that something is selected first
    If lstAddresses.SelectedIndex >= 0 Then
      ' Fill in the main form fields from the results returned from the web service
      With gobjMain
        .txtCode.Text = m_objAddresses.Addresses(lstAddresses.SelectedIndex).sCode
        .txtAddress.Text = m_objAddresses.Addresses(lstAddresses.SelectedIndex).sStreetAddress
        .txtCity.Text = m_objAddresses.Addresses(lstAddresses.SelectedIndex).sCity
        .txtProvince.Text = m_objAddresses.Addresses(lstAddresses.SelectedIndex).sProv
        .txtCountry.Text = m_objAddresses.Addresses(lstAddresses.SelectedIndex).sCountry
      End With
    End If
  End Sub
End Class
